﻿--[[ 
	-- mdManager, from Péqueño of Ysondre (EU)
]]
-----------------------------------------------------------------------------------------------------
                                         --Events on frames
------------------------------------------------------------------------------------------------------------

local EventFrame = CreateFrame("frame")
EventFrame:RegisterEvent("PLAYER_LOGIN")
local function eventHandler(self, event, ...)
	local _, c = UnitClass("player")
	if c == "HUNTER" then
		print("|cff1eff00mdManager|r: Loaded v1.0.1")
		LoadAddOn("Blizzard_MacroUI")					-- required for MAX_CHARACTER_MACROS
		local macroIndex = GetMacroIndexByName("Misdirect")
		local numglobal,numperchar = GetNumMacros()
		if macroIndex == 0 then
			if numperchar < MAX_CHARACTER_MACROS then
				CreateMacro("Misdirect", [[ability_hunter_misdirection]], "#showtooltip "..md.."", 1)
				print("|cff1eff00mdManager|r: Created the misdirection macro.")
				print("|cff1eff00mdManager|r: Open the macro editor with /macro and drag it onto your actionbar to use it.")
			else
				print("|cff1eff00mdManager|r: Couldn't create the misdirection macro, you have reached the limit of macros for this character.")
				print("|cff1eff00mdManager|r: Delete a macro and reload UI or create a blank macro named 'Misdirect'.")
			end
		end
	else 
		return
	end
	-- GetLocale method to get localization.
	if (GetLocale() == "frFR") then
		md = "Détournement"
	else
		md = "Misdirection"
	end
end
EventFrame:SetScript("OnEvent", eventHandler);


------------------------------------------------------------------------------------------------------------
                                         --Slash commands
------------------------------------------------------------------------------------------------------------
SLASH_MD_MANAGER1 = '/mdm' 								--Slash command used IG to access the addon
SLASH_MD_MANAGER2 = '/mdManager'
------------------------------------------------------------------------------------------------------------
                                         --Functions
------------------------------------------------------------------------------------------------------------
local function displayArgs()							-- function to display arguments of the /mdm command
	print('|cff1eff00mdManager|r: Arguments to |cFFFFff00/mdm|r command: ')
	print('  |cFFFFff00setMT <MT_name>|r - Sets main tank to misdirect named <MT_name>.')
	print('  |cFFFFff00setOT <OT_name>|r - Sets off tank to misdirect named <OT_name>.')
	print('  |cFFFFff00setMT/setOT target|r - Sets main/off tank to misdirect as your actual target.')	
	print('  |cFFFFff00switch|r - Switches actual tanks set to misdirect.')
	print('  |cFFFFff00status|r - Displays actual tanks set to misdirect.')
	print('  |cFFFFff00reset|r - Resets mdManager tanks values.')
	print('  |cFFFFff00help|r - Displays help about mdManager.')

end

local function combatMsg()								-- Function to display error message if player is in combat while trying to set a tank in mdManager
	print("|cff1eff00mdManager|r: can't change values, you are in combat.")
end

local function nonexistantMacroMsg()					-- Function to display error message if mdManager linked macro does not exist
	print("|cff1eff00mdManager|r: Misdirection macro does not exist.")
	print("|cff1eff00mdManager|r: Reload UI or create a blank macro named 'Misdirect'.")
	MT = nil
	OT = nil
end

local function editMdMacro()						-- Function to edit the mdManager linked macro named 'Misdirect'
	EditMacro("Misdirect",nil,nil,"#showtooltip "..md.."\n/cast [@"..MT..",nodead,help][@"..OT..",nodead,help][@pet,exists,nodead] "..md.."", 1, 1)
end

local function mdmOptions(msg)     						-- Different options of the addon to access /mdm <option1> 
	local macroInd = GetMacroIndexByName("Misdirect")	-- Get index of the macro named 'Misdirect'
	local inCombat = InCombatLockdown() 				-- Get 1 if in combat, 0 if not inf combat
	local command, arg = msg:match("^(%S*)%s*(.-)$") 	-- Sets second option of /mdm <option1> <option2> to var args
	if command:lower() == 'setmt' then 					-- setMT command, sets main tank in mdManager if specified, macro exists, and not in combat
		if macroInd == 0 then
			nonexistantMacroMsg()
		else
			if inCombat == 1 then
				combatMsg()
			else
				if arg ~= "" then
					if arg:lower() == "target" then
						MT = UnitName("target")
					else
						MT = arg
					end
					editMdMacro()
					print('|cff1eff00mdManager|r: Main Tank set: <'..MT..'>')
				else
					print('|cff1eff00mdManager|r: Argument to |cFFFFff00/mdm setMT|r command: |cFFFFff00<MT_name>|r')
				end
			end
		end
	elseif command:lower() == 'setot' then 				-- setOT command, sets off tank in mdManager if specified, macro exists, and not in combat
		if macroInd == 0 then
				nonexistantMacroMsg()
		else
			if inCombat == 1 then
				combatMsg()
			else
				if arg ~= "" then
					if arg:lower() == "target" then
						OT = UnitName("target")
					else
						OT = arg
					end
					editMdMacro()
					print('|cff1eff00mdManager|r: Off Tank set: <'..OT..'>')
				else
					print('|cff1eff00mdManager|r: Argument to |cFFFFff00/mdm setOT|r command: |cFFFFff00<OT_name>|r')
				end
			end
		end
	elseif command:lower() == 'switch' then				-- Switches tanks (MT to OT, OT to MT)
		if macroInd == 0 then
				nonexistantMacroMsg()
		else
			if inCombat == 1 then
				combatMsg()
			else
				if arg == "" then
					if((MT == nil or MT == '') and (OT == nil or OT == '')) then
						print('|cff1eff00mdManager|r: There\'s no tank to switch.')
					elseif((MT ~= nil or MT ~= '') and (OT == nil or OT == '')) then
						print('|cff1eff00mdManager|r: You can\'t switch tanks if one of them isn\'t set.')
					elseif((MT == nil or MT == '') and (OT ~= nil or OT ~= '')) then
						print('|cff1eff00mdManager|r: You can\'t switch tanks if one of them isn\'t set.')
					else
						local mtSwitch = OT
						local otSwitch = MT
						MT = mtSwitch
						OT = otSwitch
						editMdMacro()
						print('|cff1eff00mdManager|r: Actual tanks were switched.')
					end
				else 
					print('|cff1eff00mdManager|r: There\'s no argument related to |cFFFFff00/mdm switch|r command.')
				end
			end
		end
	elseif command:lower() == 'status' then 			-- Displays actual tanks if set by player and macro exists
		if macroInd == 0 then
			nonexistantMacroMsg()
		else		
			if(MT == nil or MT == '') then
				MTdisplay = 'No main tank set'
			else
				MTdisplay = MT
			end
			if(OT == nil or OT == '') then
				OTdisplay = 'No off tank set'
			else
				OTdisplay = OT
			end
			print('|cff1eff00mdManager|r Actual Tanks: |r')
			print('  |cFFFFff00Main Tank:|r '..MTdisplay)
			print('  |cFFFFff00Off Tank:|r '..OTdisplay)
		end
	elseif command:lower() == 'reset' then 				-- Resets MT and OT values
		if macroInd == 0 then
			nonexistantMacroMsg()
		else
			if inCombat == 1 then
				combatMsg()
			else
				MT = ''
				OT = ''
				editMdMacro()
				print('|cff1eff00mdManager|r: successfully reset.')
			end
		end
	elseif command:lower() == 'help' then 				-- Displays help for mdManager 
		print('|cff1eff00mdManager|r Help: ')
		print('  To set the main tank to misdirect, type /mdm setMT <MT_name>.')
		print('  To set the off tank to misdirect, type /mdm setOT <OT_name>.')
		print('  To set your target as one of the tanks, type /mdm setMT/setOT target.')
		print('  Misdirection is set by default to your pet.')
	
	else 												-- Displays available arguments of /mdm
		displayArgs()
	end
end

------------------------------------------------------------------------------------------------------------
	--Call of the mdmOptions function into the slash commands // Must remain after related function
------------------------------------------------------------------------------------------------------------
SlashCmdList['MD_MANAGER'] = mdmOptions; --Call of the function "mdmOptions" for /mdm